#include <iostream>
#include <bits/stdc++.h>
using namespace std;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    uint_fast16_t n,q;
    cin>>n>>q;
    uint_fast64_t dan[n][2];
    uint_fast64_t k[q];
    uint_fast64_t plazma=0;
    uint_fast64_t pojela=0;
    uint_fast64_t j = 0;
    uint_fast64_t z = 0;
    uint_fast64_t c = 0;
    for(int i = 0; i<n;i++)
        cin>>dan[i][0]>>dan[i][1];
    for(int i = 0;i<q;i++)
        cin>>k[i];
    while(c<q)
    {
        if(j<n)
        {
            if(z==dan[j][0])
            {
                plazma+=dan[j][1];
                j++;
            }
        }
        if(plazma>0)
        {
            pojela++;
            plazma--;
        }
        if(k[c]==z)
        {
            cout<<pojela<<endl;
            c++;
        }
        if(j==n && plazma == 0)
        {
            z=k[n-1];
        }
        else
        z++;
    }

}